## mrc 1.3.4

=== CMakeLists.txt ===
# Copyright (c) 2021 Maarten L. Hekkelman

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.10)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# set the project name
project(mrc VERSION 1.3.4)

include(Dart)
include(FindFilesystem)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Filesystem REQUIRED)

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)

	# Windows is always little endian, right?
	add_compile_definitions(LITTLE_ENDIAN)

	# Find out the processor type for the target
	if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "AMD64")
		set(COFF_TYPE "x64")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i386")
		set(COFF_TYPE "x86")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ARM64")
		set(COFF_TYPE "arm64")
	else()
		message(FATAL_ERROR "Unsupported or unknown processor type ${CMAKE_SYSTEM_PROCESSOR}")
	endif()	

	set(COFF_SPEC "--coff=${COFF_TYPE}")
endif()

find_package(Boost 1.70.0 REQUIRED COMPONENTS program_options)

include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_libraries(Boost::program_options std::filesystem)

add_custom_command(OUTPUT mrc-rsrc.obj
	COMMAND $<TARGET_FILE:mrc-bootstrap> -o mrc-rsrc.obj ${PROJECT_SOURCE_DIR}/mrsrc.h ${COFF_SPEC}
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mrsrc.h mrc-bootstrap
)

file(GLOB UNIT_TEST_RSRC LIST_DIRECTORIES true ${PROJECT_SOURCE_DIR}/rsrc/*)

add_custom_command(OUTPUT mrc-unit-test-rsrc.obj
	COMMAND $<TARGET_FILE:mrc-bootstrap> -o mrc-unit-test-rsrc.obj ${UNIT_TEST_RSRC} ${COFF_SPEC}
	DEPENDS ${UNIT_TEST_RSRC} mrc-bootstrap
)

add_executable(mrc ${PROJECT_SOURCE_DIR}/mrc.cpp mrc-rsrc.obj)
add_executable(mrc-bootstrap ${PROJECT_SOURCE_DIR}/mrc.cpp ${PROJECT_SOURCE_DIR}/dummy.cpp)
add_executable(mrc-unit-test ${PROJECT_SOURCE_DIR}/mrc-unit-test.cpp mrc-unit-test-rsrc.obj)

enable_testing()

add_test(NAME unit-test COMMAND $<TARGET_FILE:mrc-unit-test> WORKING_DIRECTORY .)

set(PACKAGE_NAME "${PROJECT_NAME}")
set(PACKAGE_VERSION "${PROJECT_VERSION}")
set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")

configure_file(${PROJECT_SOURCE_DIR}/mrc.h.in mrc.h)

install(TARGETS mrc)

if(WIN32)
	install(FILES mrc-config.cmake DESTINATION cmake)
	install(FILES mrc-manual.pdf DESTINATION doc)
else()
	install(FILES mrc-config.cmake DESTINATION share/mrc/cmake)
	install(FILES mrc.1 DESTINATION share/man/man1)
endif()

install(DIRECTORY example DESTINATION share/doc/mrc/)

=== example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# set the project name
project(mrc-user VERSION 1.0.0 LANGUAGES CXX)

# Locate the mrc executable and load the mrc_* functions
find_package(mrc)

# resources depend on C++17 features, like std::filesystem
set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Write out an mrsrc.hpp file and make sure the compiler finds it
mrc_write_header(${CMAKE_CURRENT_BINARY_DIR}/mrsrc.hpp)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# The executable to create
add_executable(mrc-user ${CMAKE_CURRENT_SOURCE_DIR}/mrc-user.cpp)

# Add the hello.txt file as a resource, more files and/or directories
# can be specified here
mrc_target_resources(mrc-user ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)

## mrc 1.2.3

=== debian/changelog ===
mrc (1.2.3-2) unstable; urgency=medium

  * Fix a copy/paste bug in 64 bit support
  * Add a define for PATH_MAX (needed for hurd)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 08 Nov 2020 19:30:06 +0100

mrc (1.2.3-1) unstable; urgency=medium

  * New upstream version supporting any architecture. 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 29 Oct 2020 19:56:53 +0100

mrc (1.2.2-2) unstable; urgency=medium

  * Team upload.
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Fri, 23 Oct 2020 08:18:11 +0200

mrc (1.2.2-1) unstable; urgency=medium

  * Initial release (Closes: #970087)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 11 Sep 2020 10:39:06 +0200

=== debian/control ===
Source: mrc
Section: devel
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends: debhelper-compat (= 13), autoconf-archive,
               libboost-dev, libboost-program-options-dev
Standards-Version: 4.5.0
Homepage: https://github.com/mhekkel/mrc
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/mrc
Vcs-Git: https://salsa.debian.org/med-team/mrc.git

Package: mrc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: resource compiler to store data in ELF object files
 This package contains the mrc resource compiler. Use it to bundle
 data files into an executable. Using the enclosed header file,
 you can access these resources from your C++ code.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%mrc-$1.tar.gz%" \
   https://github.com/mhekkel/mrc/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## mrc 1.3.4

=== debian/changelog ===
mrc (1.3.4-1) unstable; urgency=medium

  * New upstream release (with cmake config file)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 13 Oct 2021 15:53:16 +0200

mrc (1.3.3-2) unstable; urgency=medium

  * Remove 64-bit patch, it was simply incorrect

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 03 Sep 2021 10:11:14 +0200

mrc (1.3.3-1) unstable; urgency=medium

  * New upstream version, adding ABI flag.
  * Should fix build issues on most platforms (Closes: #989051)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Sep 2021 17:18:35 +0200

mrc (1.3.2-1) unstable; urgency=medium

  * New upstream version.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Sep 2021 09:53:49 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13), autoconf-archive,
-               libboost-dev, libboost-program-options-dev
-Standards-Version: 4.5.0
+               libboost-dev, libboost-program-options-dev, cmake
+Standards-Version: 4.6.0
 Homepage: https://github.com/mhekkel/mrc
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/med-team/mrc

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

## mrc 1.3.6

=== CMakeLists.txt ===
# Copyright (c) 2021 Maarten L. Hekkelman

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.10)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# set the project name
project(mrc VERSION 1.3.6)

include(Dart)
include(FindFilesystem)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Filesystem REQUIRED)

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive-)

	# Windows is always little endian, right?
	add_compile_definitions(LITTLE_ENDIAN)

	# Find out the processor type for the target
	if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "AMD64")
		set(COFF_TYPE "x64")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i386")
		set(COFF_TYPE "x86")
	elseif(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ARM64")
		set(COFF_TYPE "arm64")
	else()
		message(FATAL_ERROR "Unsupported or unknown processor type ${CMAKE_SYSTEM_PROCESSOR}")
	endif()

	set(COFF_SPEC "--coff=${COFF_TYPE}")
endif()

find_package(libmcfp QUIET)
if(NOT libmcfp_FOUND)
	add_subdirectory(libmcfp EXCLUDE_FROM_ALL)
endif()

include(VersionString)
write_version_header(${PROJECT_SOURCE_DIR}/src/)

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/mrc-rsrc.obj
	COMMAND $<TARGET_FILE:mrc-bootstrap> -o ${CMAKE_BINARY_DIR}/mrc-rsrc.obj ${PROJECT_SOURCE_DIR}/src/mrsrc.h ${COFF_SPEC}
	DEPENDS ${PROJECT_SOURCE_DIR}/src/mrsrc.h mrc-bootstrap
)

add_executable(mrc ${PROJECT_SOURCE_DIR}/src/mrc.cpp ${CMAKE_BINARY_DIR}/mrc-rsrc.obj)
add_executable(mrc-bootstrap ${PROJECT_SOURCE_DIR}/src/mrc.cpp ${PROJECT_SOURCE_DIR}/src/dummy.cpp)

target_link_libraries(mrc std::filesystem libmcfp::libmcfp)
target_link_libraries(mrc-bootstrap std::filesystem libmcfp::libmcfp)

if(ENABLE_TESTING)
	enable_testing()

	find_package(Boost REQUIRED)

	file(GLOB UNIT_TEST_RSRC LIST_DIRECTORIES true ${PROJECT_SOURCE_DIR}/rsrc/*)

	add_custom_command(OUTPUT mrc-unit-test-rsrc.obj
		COMMAND $<TARGET_FILE:mrc-bootstrap> -o mrc-unit-test-rsrc.obj ${UNIT_TEST_RSRC} ${COFF_SPEC}
		DEPENDS ${UNIT_TEST_RSRC} mrc-bootstrap
	)
	
	add_executable(mrc-unit-test ${PROJECT_SOURCE_DIR}/src/mrc-unit-test.cpp ${CMAKE_BINARY_DIR}/mrc-unit-test-rsrc.obj)
	target_link_libraries(mrc-unit-test Boost::boost)

	add_test(NAME unit-test COMMAND $<TARGET_FILE:mrc-unit-test> WORKING_DIRECTORY .)
endif()

install(TARGETS mrc)

if(WIN32)
	install(FILES cmake/mrc-config.cmake DESTINATION cmake)
	install(FILES doc/mrc-manual.pdf DESTINATION doc)
else()
	install(FILES cmake/mrc-config.cmake DESTINATION share/mrc/cmake)
	install(FILES doc/mrc.1 DESTINATION share/man/man1)
endif()

install(DIRECTORY example DESTINATION share/doc/mrc/)

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 project(mrc-user VERSION 1.0.0 LANGUAGES CXX)
 
 # Locate the mrc executable and load the mrc_* functions
-find_package(mrc)
+find_package(Mrc)
 
 # resources depend on C++17 features, like std::filesystem
 set(CXX_EXTENSIONS OFF)

=== debian/changelog ===
mrc (1.3.6-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 10:44:56 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
-Build-Depends: debhelper-compat (= 13), autoconf-archive,
+Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev,
                libboost-dev, libboost-program-options-dev, cmake
 Standards-Version: 4.6.0
 Homepage: https://github.com/mhekkel/mrc

## mrc 1.3.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 # set the project name
-project(mrc VERSION 1.3.6)
+project(mrc VERSION 1.3.10)
 
 include(Dart)
 include(FindFilesystem)
@@ -38,9 +38,14 @@
 if(MSVC)
 	# make msvc standards compliant...
 	add_compile_options(/permissive-)
+endif()
 
+if(WIN32)
 	# Windows is always little endian, right?
 	add_compile_definitions(LITTLE_ENDIAN)
+
+	# And we certainly don't need those pesky min/max macro's
+	add_compile_definitions(NOMINMAX)
 
 	# Find out the processor type for the target
 	if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "AMD64")
@@ -54,9 +59,11 @@
 	endif()
 
 	set(COFF_SPEC "--coff=${COFF_TYPE}")
+
+	message(STATUS "Using COFF spec: ${COFF_SPEC}")
 endif()
 
-find_package(libmcfp QUIET)
+find_package(libmcfp 1.2.4 QUIET)
 if(NOT libmcfp_FOUND)
 	add_subdirectory(libmcfp EXCLUDE_FROM_ALL)
 endif()

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -20,4 +20,4 @@
 
 # Add the hello.txt file as a resource, more files and/or directories
 # can be specified here
-mrc_target_resources(mrc-user ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)
+mrc_target_resources(mrc-user RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)

=== debian/changelog ===
mrc (1.3.10-1) unstable; urgency=medium

  * New upstream
  * Should fix the issue with rewriting the revision.hpp file
    (Closes: #1048225)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 15 Aug 2023 08:55:11 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
-Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev,
+Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev (>= 1.2.4),
                libboost-dev, libboost-program-options-dev, cmake
 Standards-Version: 4.6.0
 Homepage: https://github.com/mhekkel/mrc

=== debian/tests/control ===
Tests: run-build-test
Depends: build-essential, cmake, mrc
Restrictions: allow-stderr

## mrc 1.3.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,15 +25,13 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 # set the project name
-project(mrc VERSION 1.3.10)
+project(mrc VERSION 1.3.13)
 
-include(Dart)
-include(FindFilesystem)
+include(CTest)
 
-set(CMAKE_CXX_STANDARD 17)
+set(CXX_EXTENSIONS OFF)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
-
-find_package(Filesystem REQUIRED)
 
 if(MSVC)
 	# make msvc standards compliant...
@@ -64,8 +62,17 @@
 endif()
 
 find_package(libmcfp 1.2.4 QUIET)
+
 if(NOT libmcfp_FOUND)
-	add_subdirectory(libmcfp EXCLUDE_FROM_ALL)
+	include(FetchContent)
+
+	FetchContent_Declare(
+		libmcfp
+		GIT_REPOSITORY https://github.com/mhekkel/libmcfp
+		GIT_TAG v1.2.4
+	)
+
+	FetchContent_MakeAvailable(libmcfp)
 endif()
 
 include(VersionString)
@@ -79,13 +86,23 @@
 add_executable(mrc ${PROJECT_SOURCE_DIR}/src/mrc.cpp ${CMAKE_BINARY_DIR}/mrc-rsrc.obj)
 add_executable(mrc-bootstrap ${PROJECT_SOURCE_DIR}/src/mrc.cpp ${PROJECT_SOURCE_DIR}/src/dummy.cpp)
 
-target_link_libraries(mrc std::filesystem libmcfp::libmcfp)
-target_link_libraries(mrc-bootstrap std::filesystem libmcfp::libmcfp)
+target_link_libraries(mrc libmcfp::libmcfp)
+target_link_libraries(mrc-bootstrap libmcfp::libmcfp)
 
-if(ENABLE_TESTING)
-	enable_testing()
+if(BUILD_TESTING)
+	find_package(Catch2 3 QUIET)
 
-	find_package(Boost REQUIRED)
+	if(NOT Catch2_FOUND)
+		Include(FetchContent)
+
+		FetchContent_Declare(
+			Catch2
+			GIT_REPOSITORY https://github.com/catchorg/Catch2.git
+			GIT_TAG v3.5.2 # or a later release
+		)
+
+		FetchContent_MakeAvailable(Catch2)
+	endif()
 
 	file(GLOB UNIT_TEST_RSRC LIST_DIRECTORIES true ${PROJECT_SOURCE_DIR}/rsrc/*)
 
@@ -93,9 +110,9 @@
 		COMMAND $<TARGET_FILE:mrc-bootstrap> -o mrc-unit-test-rsrc.obj ${UNIT_TEST_RSRC} ${COFF_SPEC}
 		DEPENDS ${UNIT_TEST_RSRC} mrc-bootstrap
 	)
-	
+
 	add_executable(mrc-unit-test ${PROJECT_SOURCE_DIR}/src/mrc-unit-test.cpp ${CMAKE_BINARY_DIR}/mrc-unit-test-rsrc.obj)
-	target_link_libraries(mrc-unit-test Boost::boost)
+	target_link_libraries(mrc-unit-test Catch2::Catch2WithMain)
 
 	add_test(NAME unit-test COMMAND $<TARGET_FILE:mrc-unit-test> WORKING_DIRECTORY .)
 endif()
@@ -110,4 +127,6 @@
 	install(FILES doc/mrc.1 DESTINATION share/man/man1)
 endif()
 
-install(DIRECTORY example DESTINATION share/doc/mrc/)
+install(DIRECTORY examples DESTINATION share/doc/mrc/)
+
+# add_subdirectory(examples/simple)

=== examples/simple/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

list(PREPEND CMAKE_PREFIX_PATH ../../cmake)

# set the project name
project(mrc-user VERSION 1.0.0 LANGUAGES CXX)

# Locate the mrc executable and load the mrc_* functions
# This of course only works when you have installed mrc already
find_package(mrc)

# resources depend on C++17 features, like std::filesystem
set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Write out an mrsrc.hpp file and make sure the compiler finds it
mrc_write_header(${CMAKE_CURRENT_BINARY_DIR}/mrsrc.hpp)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# The executable to create
add_executable(mrc-user ${CMAKE_CURRENT_SOURCE_DIR}/mrc-user.cpp)

# # Add the hello.txt file as a resource, more files and/or directories
# # can be specified here
# mrc_target_resources(mrc-user CREATE_ELF_TEMPLATE VERBOSE
# 	RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)
#
# But you can also create a static library containing the resources
# and then link to that static library:

add_library(rsrc STATIC)
set_target_properties(rsrc PROPERTIES LINKER_LANGUAGE "CXX")
mrc_target_resources(rsrc CREATE_ELF_TEMPLATE VERBOSE
 	RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)
target_link_libraries(mrc-user PRIVATE rsrc)

=== debian/changelog ===
mrc (1.3.13-2) unstable; urgency=medium

  * Fix autopkgtest

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 28 Oct 2024 20:51:03 +0100

mrc (1.3.13-1) unstable; urgency=medium

  * patch versionstring.cmake
  * update dependency on libmcfp, cleanup
  * New upstream version 1.3.13

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 28 Oct 2024 19:32:07 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev (>= 1.2.4),
-               libboost-dev, libboost-program-options-dev, cmake
+               libboost-dev, libboost-program-options-dev, cmake, catch2
 Standards-Version: 4.6.0
 Homepage: https://github.com/mhekkel/mrc
 Rules-Requires-Root: no

## mrc 1.3.14

=== debian/changelog ===
mrc (1.3.14-1) unstable; urgency=medium

  * Fix mrc-config.cmake file.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 20 Jan 2025 09:19:24 +0100

## mrc 1.3.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 # set the project name
-project(mrc VERSION 1.3.13)
+project(mrc VERSION 1.3.15)
 
 include(CTest)
 
@@ -61,18 +61,18 @@
 	message(STATUS "Using COFF spec: ${COFF_SPEC}")
 endif()
 
-find_package(libmcfp 1.2.4 QUIET)
+find_package(mcfp 1.3.5 QUIET)
 
-if(NOT libmcfp_FOUND)
+if(NOT mcfp_FOUND)
 	include(FetchContent)
 
 	FetchContent_Declare(
-		libmcfp
+		mcfp
 		GIT_REPOSITORY https://github.com/mhekkel/libmcfp
-		GIT_TAG v1.2.4
+		GIT_TAG v1.3.5
 	)
 
-	FetchContent_MakeAvailable(libmcfp)
+	FetchContent_MakeAvailable(mcfp)
 endif()
 
 include(VersionString)
@@ -86,8 +86,8 @@
 add_executable(mrc ${PROJECT_SOURCE_DIR}/src/mrc.cpp ${CMAKE_BINARY_DIR}/mrc-rsrc.obj)
 add_executable(mrc-bootstrap ${PROJECT_SOURCE_DIR}/src/mrc.cpp ${PROJECT_SOURCE_DIR}/src/dummy.cpp)
 
-target_link_libraries(mrc libmcfp::libmcfp)
-target_link_libraries(mrc-bootstrap libmcfp::libmcfp)
+target_link_libraries(mrc mcfp::mcfp)
+target_link_libraries(mrc-bootstrap mcfp::mcfp)
 
 if(BUILD_TESTING)
 	find_package(Catch2 3 QUIET)
@@ -98,7 +98,7 @@
 		FetchContent_Declare(
 			Catch2
 			GIT_REPOSITORY https://github.com/catchorg/Catch2.git
-			GIT_TAG v3.5.2 # or a later release
+			GIT_TAG v3.8.0 # or a later release
 		)
 
 		FetchContent_MakeAvailable(Catch2)
@@ -112,9 +112,14 @@
 	)
 
 	add_executable(mrc-unit-test ${PROJECT_SOURCE_DIR}/src/mrc-unit-test.cpp ${CMAKE_BINARY_DIR}/mrc-unit-test-rsrc.obj)
-	target_link_libraries(mrc-unit-test Catch2::Catch2WithMain)
 
-	add_test(NAME unit-test COMMAND $<TARGET_FILE:mrc-unit-test> WORKING_DIRECTORY .)
+	if(TARGET Catch2::Catch2WithMain)
+		target_link_libraries(mrc-unit-test Catch2::Catch2WithMain)
+
+		add_test(NAME unit-test COMMAND $<TARGET_FILE:mrc-unit-test> WORKING_DIRECTORY .)
+	else()
+		message(WARNING "No Catch2::Catch2WithMain target, something is wrong")
+	endif()
 endif()
 
 install(TARGETS mrc)

=== examples/esp-idf-rsrc/CMakeLists.txt ===
# The following lines of boilerplate have to be in your project's
# CMakeLists in this exact order for cmake to work correctly
cmake_minimum_required(VERSION 3.16)

include($ENV{IDF_PATH}/tools/cmake/project.cmake)
project(my-rsrc-app)

=== examples/simple/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# set the project name
project(mrc-user VERSION 1.0.0 LANGUAGES CXX)

# Locate the mrc executable and load the mrc_* functions
find_package(Mrc)

# resources depend on C++17 features, like std::filesystem
set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Write out an mrsrc.hpp file and make sure the compiler finds it
mrc_write_header(${CMAKE_CURRENT_BINARY_DIR}/mrsrc.hpp)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# The executable to create
add_executable(mrc-user ${CMAKE_CURRENT_SOURCE_DIR}/mrc-user.cpp)

# Add the hello.txt file as a resource, more files and/or directories
# can be specified here
mrc_target_resources(mrc-user CREATE_ELF_TEMPLATE VERBOSE
	RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)

=== examples/esp-idf-rsrc/main/CMakeLists.txt ===
find_package(Mrc)

idf_component_register(SRCS esp-rsrc-app.cpp
                       INCLUDE_DIRS ".")

mrc_write_header(${CMAKE_CURRENT_SOURCE_DIR}/mrsrc.hpp)

mrc_target_resources(${COMPONENT_LIB} CREATE_ELF_TEMPLATE
	RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/hello.txt)

=== debian/changelog ===
mrc (1.3.15-2) unstable; urgency=medium

  * fix libmcfp dependency

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 17:36:29 +0100

mrc (1.3.15-1) unstable; urgency=medium

  * New upstream version 1.3.15

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 13:43:55 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
-Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev (>= 1.2.4),
-               libboost-dev, libboost-program-options-dev, cmake, catch2
-Standards-Version: 4.6.0
+Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev (>= 1.3.5-2~),
+               cmake, libcatch2-dev
+Standards-Version: 4.6.2
 Homepage: https://github.com/mhekkel/mrc
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/med-team/mrc

## mrc 1.3.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,9 +25,10 @@
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 # set the project name
-project(mrc VERSION 1.3.15)
+project(mrc VERSION 1.3.16)
 
 include(CTest)
+include(CPM)
 
 set(CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_STANDARD 20)
@@ -61,19 +62,8 @@
 	message(STATUS "Using COFF spec: ${COFF_SPEC}")
 endif()
 
-find_package(mcfp 1.3.5 QUIET)
-
-if(NOT mcfp_FOUND)
-	include(FetchContent)
-
-	FetchContent_Declare(
-		mcfp
-		GIT_REPOSITORY https://github.com/mhekkel/libmcfp
-		GIT_TAG v1.3.5
-	)
-
-	FetchContent_MakeAvailable(mcfp)
-endif()
+set(CPM_USE_LOCAL_PACKAGES ON)
+CPMAddPackage("https://forge.hekkelman.net/maarten/mcfp.git@1.4.1")
 
 include(VersionString)
 write_version_header(${PROJECT_SOURCE_DIR}/src/)
@@ -90,19 +80,7 @@
 target_link_libraries(mrc-bootstrap mcfp::mcfp)
 
 if(BUILD_TESTING)
-	find_package(Catch2 3 QUIET)
-
-	if(NOT Catch2_FOUND)
-		Include(FetchContent)
-
-		FetchContent_Declare(
-			Catch2
-			GIT_REPOSITORY https://github.com/catchorg/Catch2.git
-			GIT_TAG v3.8.0 # or a later release
-		)
-
-		FetchContent_MakeAvailable(Catch2)
-	endif()
+	CPMAddPackage("gh:catchorg/Catch2@3.5.0")
 
 	file(GLOB UNIT_TEST_RSRC LIST_DIRECTORIES true ${PROJECT_SOURCE_DIR}/rsrc/*)
 
@@ -132,6 +110,6 @@
 	install(FILES doc/mrc.1 DESTINATION share/man/man1)
 endif()
 
-install(DIRECTORY examples DESTINATION share/doc/mrc/)
+install(DIRECTORY examples DESTINATION share/doc/mrc PATTERN build EXCLUDE)
 
 # add_subdirectory(examples/simple)

=== examples/simple/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 project(mrc-user VERSION 1.0.0 LANGUAGES CXX)
 
 # Locate the mrc executable and load the mrc_* functions
-find_package(Mrc)
+find_package(mrc)
 
 # resources depend on C++17 features, like std::filesystem
 set(CXX_EXTENSIONS OFF)

=== examples/esp-idf-rsrc/main/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-find_package(Mrc)
+find_package(mrc)
 
 idf_component_register(SRCS esp-rsrc-app.cpp
                        INCLUDE_DIRS ".")

=== debian/changelog ===
mrc (1.3.16-1) unstable; urgency=medium

  * New upstream version 1.3.16

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 26 May 2025 10:31:36 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
-Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev (>= 1.3.5-2~),
+Build-Depends: debhelper-compat (= 13), autoconf-archive, libmcfp-dev (>= 1.4.2-1~),
                cmake, libcatch2-dev
 Standards-Version: 4.6.2
 Homepage: https://github.com/mhekkel/mrc
